#ifndef LOGSIMA_H
#define LOGSIMA_H

#include "logsim.h"
#include "logdef.h"
#include "logdig.h"
#include <utils/newasm.h>
#include "tool.h"
#include "gate.h"


#ifdef LOGSIMA_G
#define vextern
#else
#define vextern extern
#endif 


typedef struct nodeinfo {
  log_16_value v, v0, v00, defv, truev;
} nodeinfo;

typedef struct kindinfo {
  na_long info;
  int hasproc, instance;
  short numppins, numpvars; // TODO move in gateinfo
  void (*kindproc) (log_16_action *act);
  log_krec *knext;
} kindinfo;

typedef struct gateinfo {
  log_nrec **ppins;
  char *pvars;
} gateinfo;


vextern log_tool *logsima_tool_16;
vextern log_16_action logsima_action;
extern void (*logsima_dig_inst) (log_16_action *act);


extern void logsima_init ();
extern void executegates (int *active, log_grec *g);
extern void executeprog (uchar *pr, log_nrec **pins, gateinfo *ginfo,
			    na_long *vars);
extern void clearnodes (log_nrec *n);
extern void copynodes (log_nrec *n, int *stable);
extern void callgate (log_16_actionkinds action);

#endif /*LOGSIMA_H*/


