#ifndef PAGE_H
#define PAGE_H

#include "logdef.h"
#include "gate.h"
#include "wire.h"

typedef struct log_lrec log_lrec;

typedef struct log_regrec {
  short pagenum;
  short x1, y1, x2, y2;
  long regstamp;
  na_long info;
  struct log_regrec *next;
} log_regrec;   /* Sensitive region */

typedef struct log_page {
	log_grec *gbase; /* base gate of the page */
	log_srec *sbase; /* base solderpoint of the page */
	log_hwrec *hwbase; /* base horizontal wire of the page */
	log_vwrec *vwbase; /* base vertical wire of the page */
	log_lrec *lbase; /* base label of page */
	log_brec *bbase; /* base box of page */
	log_regrec *pageregions; /* base region of page */
	long pagestamp;
	int pagechanged;
} log_page;

void chpage(log_page *page);

void chpageplace(log_page *page, short x1, short y1, short x2, short y2);

int isPageEmpty(log_page *page);

int isPageNull(log_page *page);

int isPageChanged(log_page *page);

int anychanged();

void newpage(short pg);

int pagembb(short pg, short *x1, short *y1, short *x2, short *y2);

log_page *pageAlloc();

void pageFree(log_page **page);

void pageClear(log_page *page);

#endif
