#ifndef LOG_TOOL_H
#define LOG_TOOL_H

#include "logdef.h"
#include "gate.h"
#include "log_action.h"

typedef struct log_tool {
  char name[17];
  void (*proc) (log_action_t *act);
  char *fname, *comment;
  char *shortname;
  unsigned ready : 1, simulator : 1, keep : 1, nostatus : 1, tstepflag : 1;
  uchar simtype;
  double nexttstep;
  strlist_t *nlbl, *hlbl;
  short nnumattrs, hnumattrs;
  log_kattrrec *nattr, *hattr;
  na_long info;
  struct log_tool *next;
  long netstamp;   /* Changes to circuit network */
  double deltatime;
} log_tool;


void newtool(log_tool **t, char *name);
log_tool *findtool(char *name_);
void calltool(log_tool *t, log_actionkinds act);
void calltoolgate(log_grec *g, log_actionkinds act);
void calltoolnode(log_nrec *n, log_actionkinds act);
void calltoolkind(log_krec *k, log_actionkinds act);
void calltools(log_actionkinds act);
void callsimtools(log_actionkinds act);
void closetool(log_tool *tp);
void closetools();

#endif
