#include "pagewriter.h"

#include "logfont.h"
#include <utils/filepack.h>
#include <graphics/newcrt.h>
#include <graphics/newci.h>
#include "log.h"
#include "window.h"
#include "tool.h"
#include "utils.h"
#include "box.h"

short countnode(log_nrec *n, struct LOC_savepage *LINK)
{
	short i;
	log_nrec *n1;

	i = 1;
	n1 = LINK->firstnode;
	while (n1 != n && n1 != NULL)
	{
		i++;
		n1 = (log_nrec *)n1->temp;
	}
	return i;
}

short counthw(log_hwrec *hw, struct LOC_savepage *LINK)
{
	short i;
	log_hwrec *hw1;

	i = 1;
	hw1 = LINK->firsthwire;
	while (hw1 != hw && hw1 != NULL)
	{
		i++;
		hw1 = (log_hwrec *)hw1->temp;
	}
	if (hw1 == NULL)
		nc_printf("\007Unable to find hwire %ld\n", (long)hw);
	return i;
}

short countvw(log_vwrec *vw, struct LOC_savepage *LINK)
{
	short i;
	log_vwrec *vw1;

	i = 1;
	vw1 = LINK->firstvwire;
	while (vw1 != vw && vw1 != NULL)
	{
		i++;
		vw1 = (log_vwrec *)vw1->temp;
	}

	if (vw1 == NULL)
		nc_printf("\007Unable to find vwire %ld\n", (long)vw);
	return (i + LINK->numhw);
}

int eqattr(log_kattrrec *ka, log_gattrrec *ga, struct LOC_savepage *LINK)
{
	int Result;

	switch (ka->dtype)
	{

		case 'R':
		case 'U':
		case 'F':
			Result = (ga->blnk == ka->blnk && ga->UU.r == ka->UU.U82.r);
			break;

		case 'I':
		case 'H':
			Result = (ga->blnk == ka->blnk && ga->UU.U73.i1 == ka->UU.U73.i1);
			break;

		case 'C':
			Result = (strcmp(ga->UU.c, ka->UU.c) == 0);
			break;

		case 'A':
			Result = (strcmp(ga->UU.sp, ka->UU.sp) == 0);
			break;

		case 'B':
			Result = (ga->blnk == ka->blnk && ga->UU.b == ka->UU.b);
			break;

		case 'V':
			Result = (ga->UU.nv == ka->UU.U86.dv);
			break;
	}
	return Result;
}

strlist_t *attrname(short i, strlist_t *lbl, struct LOC_savepage *LINK)
{
	strlist_t *l1;

	l1 = lbl;
	while (l1 != NULL && l1->kind != '\001')
		l1 = l1->next;

	if (l1 == NULL)
		return l1;
	l1 = (strlist_t *)l1->value;

	while (l1 != NULL && (long)l1->value != i)
		l1 = l1->next;

	return l1;
}

short countattrs(log_gattrrec *gattr, short numattrs, log_kattrrec *kattr, strlist_t *lbl, struct LOC_savepage *LINK)
{
	short i, j;

	j = 0;
	for (i = 1; i <= numattrs; i++)
	{
		if (!eqattr(&kattr[i - 1], &gattr[i - 1], LINK) &&
				attrname(i, lbl, LINK) == NULL)
			j = i;
	}
	LINK->maxunat = j;
	for (i = j; i < numattrs; i++)
	{
		if (!eqattr(&kattr[i], &gattr[i], LINK))
			j++;
	}
	return j;
}

void writeattrs(FILE **f, log_gattrrec *gattr, short numattrs, log_kattrrec *kattr, strlist_t *lbl, struct LOC_savepage *LINK)
{
	short num, i;   /*reads maxunat from last call to countattrs*/
	strlist_t *l1;
	char STR2[81];

	num = countattrs(gattr, numattrs, kattr, lbl, LINK);
	for (i = 1; i <= numattrs; i++)
	{
		if (i <= LINK->maxunat || !eqattr(&kattr[i - 1], &gattr[i - 1], LINK))
		{
			l1 = attrname(i, lbl, LINK);
			if (l1 != NULL)
			{
				fprintf(*f, "[%s] ", l1->s);
			}
			if (gattr[i - 1].blnk)
			{
				fprintf(*f, "X\n");
			}
			else
			{
				putc(kattr[i - 1].dtype, *f);
				switch (kattr[i - 1].dtype)
				{

					case 'R':
					case 'U':
					case 'F':
						fprintf(*f, "%s\n", realstr(STR2, gattr[i - 1].UU.r, kattr[i - 1].prec));
						break;

					case 'I':
					case 'H':
						fprintf(*f, "%ld\n", gattr[i - 1].UU.U73.i1);
						break;

					case 'C':
						fprintf(*f, "%s\n", gattr[i - 1].UU.c);
						break;

					case 'A':
						fprintf(*f, "%s\n", gattr[i - 1].UU.sp);
						break;

					case 'B':
						fprintf(*f, "%d\n", gattr[i - 1].UU.b);
						break;

					case 'V':
						fprintf(*f, "%d\n", gattr[i - 1].UU.nv);
						break;
				}
			}
		}
	}
}


void savepage(short pgnum, char *filename_)
{
	struct LOC_savepage V;
	char filename[256];
	FILE *f;
	log_grec *g;
	log_srec *s, *firstsolder;
	log_hwrec *hw;
	log_vwrec *vw;
	log_lrec *l, *firstlabel;
	log_brec *b, *firstbox;
	log_krec *k;
	log_hnrec *hn;
	char buf[256];
	log_nrec *n1, *lastnode;
	short i, j, count, numvw, numnodes;
	char STR1[9];
	char STR2[256];
	short FORLIM;

	strcpy(filename, filename_);
	f = NULL;
	newci_fixfname(filename, "lgf", "");
	if (*filename != '\0' && isPageEmpty(gg.pages[pgnum - 1]) && access(filename, F_OK) == 0)
	{
		sprintf(STR2, "File %s not overwritten with empty page!", filename);
		message(STR2);
		*filename = '\0';
	}

	if (*filename != '\0')
	{
		TRY(try24);
		strcpy(buf, filename);
		newci_forcefname(buf, "lfo", "");
		fp_change(filename, buf);
		RECOVER(try24);
		if (P_escapecode == -20)
			_Escape(P_escapecode);
		ENDTRY(try24);
		if (f != NULL)
			f = freopen(filename, "w", f);
		else
			f = fopen(filename, "w");
		if (f == NULL)
			_EscIO(FileNotFound);
		fprintf(f, "-5\n");
		/* if vlsi then
		   writeln(f, 'f v')
		   else */
		fprintf(f, "f s\n");
		n1 = gg.nbase;
		while (n1 != NULL)
		{
			n1->flag = false;
			n1 = n1->next;
		}

		hw = gg.pages[pgnum - 1]->hwbase;
		while (hw != NULL)
		{
			hw->node->flag = true;
			hw = hw->next;
		}

		vw = gg.pages[pgnum - 1]->vwbase;
		while (vw != NULL)
		{
			vw->node->flag = true;
			vw = vw->next;
		}

		g = gg.pages[pgnum - 1]->gbase;
		while (g != NULL)
		{
			FORLIM = g->kind->numpins;
			for (i = 0; i < FORLIM; i++)
				g->pin[i]->flag = true;
			g = g->next;
		}

		numnodes = 0;
		V.firstnode = NULL;
		lastnode = NULL;
		n1 = gg.nbase;
		while (n1 != NULL)
		{
			if (n1->flag)
			{
				numnodes++;
				if (lastnode != NULL)
					lastnode->temp = (void *)n1;
				else
					V.firstnode = n1;
				n1->temp = NULL;
				lastnode = n1;
			}
			n1 = n1->next;
		}
		fprintf(f, "n %d\n", numnodes);
		n1 = V.firstnode;
		while (n1 != NULL)
		{
			fprintf(f, "%d ", n1->simtype->simtype);
			fprintf(f, "%d\n", countattrs(n1->attr, n1->simtype->nnumattrs, n1->simtype->nattr,
						n1->simtype->nlbl, &V));
			writeattrs(&f, n1->attr, n1->simtype->nnumattrs, n1->simtype->nattr, n1->simtype->nlbl, &V);
			gg.actfile = &f;
			gg.actflag = false;
			calltoolnode(n1, act_writenode);
			putc('\n', f);
			n1 = (log_nrec *)n1->temp;
		}

		/* ensure that each signal has a named gate on this page. */
		FORLIM = gg.lastsignal;
		for (i = 0; i < FORLIM; i++)
			gg.signaltab[i].f = false;

		g = gg.pages[pgnum - 1]->gbase;
		while (g != NULL)
		{
			if (g->sig > 0 && g->sig <= gg.lastsignal && gg.signaltab[g->sig -1].np != NULL &&
					gg.signaltab[g->sig -1].np->flag)
				gg.signaltab[g->sig -1].f = true;
			g = g->next;
		}

		count = 0;
		for (i = 0; i < FORLIM; i++)
		{
			if (gg.signaltab[i].f)
				count++;
		}

		fprintf(f, "s %d\n", count);
		for (i = 0; i < FORLIM; i++)
		{
			if (gg.signaltab[i].f)
				fprintf(f, "%d %s\n",
						countnode(gg.signaltab[i].np, &V), gg.signaltab[i].name);
		}
		V.numhw = 0;
		hw = gg.pages[pgnum - 1]->hwbase;
		V.firsthwire = NULL;
		while (hw != NULL)
		{
			V.numhw++;
			hw->temp = (void *)V.firsthwire;
			V.firsthwire = hw;
			hw = hw->next;
		}
		numvw = 0;
		vw = gg.pages[pgnum - 1]->vwbase;
		V.firstvwire = NULL;
		while (vw != NULL)
		{
			numvw++;
			vw->temp = (void *)V.firstvwire;
			V.firstvwire = vw;
			vw = vw->next;
		}
		fprintf(f, "w %d\n", V.numhw + numvw);
		hw = V.firsthwire;
		while (hw != NULL)
		{
			fprintf(f, "%d %d %d %d %d %s\n",
					hw->x1, hw->y, hw->x2, hw->y, countnode(hw->node, &V),
					colorname(STR1, hw->wcolr));
			hw = (log_hwrec *)hw->temp;
		}
		vw = V.firstvwire;
		while (vw != NULL)
		{
			fprintf(f, "%d %d %d %d %d %s\n",
					vw->x, vw->y1, vw->x, vw->y2, countnode(vw->node, &V),
					colorname(STR1, vw->wcolr));
			vw = (log_vwrec *)vw->temp;
		}
		count = 0;
		s = gg.pages[pgnum - 1]->sbase;
		firstsolder = NULL;
		while (s != NULL)
		{
			count++;
			s->temp = (void *)firstsolder;
			firstsolder = s;
			s = s->next;
		}
		fprintf(f, "p %d\n", count);
		s = firstsolder;
		while (s != NULL)
		{
			fprintf(f, "%d %d", s->x, s->y);
			if (s->hwire != NULL)
				fprintf(f, " %d", counthw(s->hwire, &V));
			if (s->hwire2 != NULL)
				fprintf(f, " %d", counthw(s->hwire2, &V));
			if (s->vwire != NULL)
				fprintf(f, " %d", countvw(s->vwire, &V));
			if (s->vwire2 != NULL)
				fprintf(f, " %d", countvw(s->vwire2, &V));
			putc('\n', f);
			s = (log_srec *)s->temp;
		}
		count = 0;
		l = gg.pages[pgnum - 1]->lbase;
		firstlabel = NULL;
		while (l != NULL)
		{
			count++;
			l->temp = (void *)firstlabel;
			firstlabel = l;
			l = l->next;
		}
		fprintf(f, "l %d\n", count);
		l = firstlabel;
		while (l != NULL)
		{
			fprintf(f, "%d %d %ld %s\n",
					l->x, l->y, m_strwidth(logfont_lfont, l->name) / log_scale0,
					l->name);
			l = (log_lrec *)l->temp;
		}
		count = 0;
		b = gg.pages[pgnum - 1]->bbase;
		firstbox = NULL;
		while (b != NULL)
		{
			count++;
			b->temp = (void *)firstbox;
			firstbox = b;
			b = b->next;
		}
		fprintf(f, "b %d\n", count);
		b = firstbox;
		while (b != NULL)
		{
			fprintf(f, "%d %d %d %d\n", b->x1, b->y1, b->x2, b->y2);
			b = (log_brec *)b->temp;
		}
		count = 0;
		g = gg.pages[pgnum - 1]->gbase;
		while (g != NULL)
		{
			count++;
			g = g->next;
		}
		fprintf(f, "g %d\n", count);
		g = gg.pages[pgnum - 1]->gbase;
		while (g != NULL)
		{
			k = g->kind;
			fprintf(f, "%s\n", k->name);
			i = 0;
			if (g->sig != 0)
			{
				FORLIM = g->sig;
				for (j = 0; j < FORLIM; j++)
				{
					if (gg.signaltab[j].f)
						i++;
				}
			}
			fprintf(f, "%d %d %d ", g->x, g->y, g->rot);
			fprintf(f, "%d %ld %d ", g->gc, (long)g->vars, i);
			fprintf(f, "%d\n", countattrs(g->attr, k->numattrs, k->attr, k->lbl, &V));
			FORLIM = k->numpins;
			for (i = 1; i <= FORLIM; i++)
			{
				if (i != 1)
					putc(' ', f);
				fprintf(f, "%d", countnode(g->pin[i - 1], &V));
			}
			putc('\n', f);
			writeattrs(&f, g->attr, k->numattrs, k->attr, k->lbl, &V);
			gg.actfile = &f;
			gg.actflag = false;
			calltoolgate(g, act_writegate);
			putc('\n', f);
			g = g->next;
		}
		fprintf(f, "h %d\n", hncount);
		hn = gg.hnbase;
		while (hn != NULL)
		{
			n1 = gg.signaltab[hn->sig - 1].np;
			fprintf(f, "%d ", hn->y);
			fprintf(f, "%d", countattrs(hn->attr, n1->simtype->hnumattrs, n1->simtype->hattr, n1->simtype->hlbl, &V));
			fprintf(f, " %s\n", gg.signaltab[hn->sig - 1].name);
			writeattrs(&f, hn->attr, n1->simtype->hnumattrs, n1->simtype->hattr, n1->simtype->hlbl, &V);
			hn = hn->next;
		}
		fprintf(f, ".\n");
		if (f != NULL)
			fclose(f);
		f = NULL;
		gg.pages[pgnum - 1]->pagechanged = false;
		if (curfilename[pgnum - 1] == NULL)
			curfilename[pgnum - 1] = (char *)Malloc(256);
		strcpy(curfilename[pgnum - 1], filename);
	}
	if (f != NULL)
		fclose(f);
}


void emergencysave(short pgnum)
{
	char filename[256];

	TRY(try25);
	nc_printf("File name");
	if (curfilename[pgnum - 1] != NULL)
		nc_printf("(was %s)", curfilename[pgnum - 1]);
	nc_printf(": ");
	nc_fgets(filename, 256, stdin);
	if (*filename != '\0')
		savepage(pgnum, filename);
	RECOVER(try25);
	if (P_escapecode == -20)
		_Escape(P_escapecode);
	nc_printf("Saving page %d failed.\n", pgnum);
	ENDTRY(try25);
}


void safesavepage(short pgnum, char *fn)
{
	long i, j;

	if (*fn == '\0')
		return;
	beginbottom();
	TRY(try26);
	nc_printf("Saving file %s\n", fn);
	m_alpha_on();
	savepage(pgnum, fn);
	endbottom();
	RECOVER(try26);
	i = P_escapecode;
	j = P_ioresult;
	endbottom();
	beginerror();
	if (Debugging || debugprint || gg.traceflag)
		nc_printf("%ld/%ld/%ld   ", i, j, EXCP_LINE);
	nc_printf("Unable to save file %s\n", fn);
	enderror();
	ENDTRY(try26);
}
